diff --git a/modules/routes/routeChatbot.py b/modules/routes/routeChatbot.py
index 25e24164..4975bf45 100644
--- a/modules/routes/routeChatbot.py
+++ b/modules/routes/routeChatbot.py
@@ -80,9 +80,9 @@ async def stream_chatbot_start(
             queue = event_manager.create_queue(workflow.id)
         
         async def event_stream():
-            """Async generator for SSE events."""
+            """Async generator for SSE events - pure event-driven streaming (no polling)."""
             try:
-                # Get interface for status checks and chat data
+                # Get interface for initial data and status checks
                 interfaceDbChat = getServiceChat(currentUser)
                 
                 # Get current workflow to check if resuming and get current round
@@ -90,7 +90,7 @@ async def stream_chatbot_start(
                 current_round = current_workflow.currentRound if current_workflow else None
                 is_resuming = final_workflow_id is not None and current_round and current_round > 1
                 
-                # Send initial chat data (exact format as chatData endpoint)
+                # Send initial chat data (exact format as chatData endpoint) - only once at start
                 try:
                     chatData = interfaceDbChat.getUnifiedChatData(workflow.id, None)
                     if chatData.get("items"):
@@ -126,32 +126,18 @@ async def stream_chatbot_start(
                             }
                             # Emit item directly in exact chatData format: {type, createdAt, item}
                             yield f"data: {json.dumps(serializable_item)}\n\n"
-                        
-                        # Set initial timestamp for incremental fetching
-                        if filtered_items:
-                            timestamps = [parseTimestamp(item.get("createdAt"), default=0) for item in filtered_items]
-                            last_chatdata_timestamp = max(timestamps) if timestamps else None
-                        else:
-                            last_chatdata_timestamp = None
-                    else:
-                        last_chatdata_timestamp = None
                 except Exception as e:
                     logger.warning(f"Error fetching initial chat data: {e}")
-                    last_chatdata_timestamp = None
                 
                 # Keepalive interval (30 seconds)
                 keepalive_interval = 30.0
                 last_keepalive = asyncio.get_event_loop().time()
                 
-                # Status check interval (check workflow status every 3 seconds)
-                status_check_interval = 3.0
+                # Status check interval (check workflow status every 5 seconds - less frequent since we're event-driven)
+                status_check_interval = 5.0
                 last_status_check = asyncio.get_event_loop().time()
                 
-                # Chat data fetch interval (fetch chat data every 0.5 seconds for real-time updates)
-                chatdata_fetch_interval = 0.5
-                last_chatdata_fetch = asyncio.get_event_loop().time()
-                
-                # Stream events until completion or timeout
+                # Stream events until completion or timeout - pure event-driven (no polling)
                 timeout = 300.0  # 5 minutes max
                 start_time = asyncio.get_event_loop().time()
                 
@@ -159,7 +145,6 @@ async def stream_chatbot_start(
                     # Check timeout
                     elapsed = asyncio.get_event_loop().time() - start_time
                     if elapsed > timeout:
-                        # Timeout - just close stream, don't emit non-chatData format events
                         logger.info(f"Stream timeout for workflow {workflow.id}")
                         break
                     
@@ -170,76 +155,29 @@ async def stream_chatbot_start(
                     
                     current_time = asyncio.get_event_loop().time()
                     
-                    # Periodically check workflow status and fetch chat data
+                    # Periodically check workflow status (less frequent since we're event-driven)
                     if current_time - last_status_check >= status_check_interval:
                         try:
                             current_workflow = interfaceDbChat.getWorkflow(workflow.id)
                             if current_workflow and current_workflow.status == "stopped":
                                 logger.info(f"Workflow {workflow.id} was stopped, closing stream")
-                                # Don't emit stopped event - just close stream
                                 break
                         except Exception as e:
                             logger.warning(f"Error checking workflow status: {e}")
                         last_status_check = current_time
                     
-                    # Periodically fetch and emit chat data
-                    if current_time - last_chatdata_fetch >= chatdata_fetch_interval:
-                        try:
-                            chatData = interfaceDbChat.getUnifiedChatData(workflow.id, last_chatdata_timestamp)
-                            if chatData.get("items"):
-                                # Filter items by round number if resuming
-                                filtered_items = []
-                                for item in chatData["items"]:
-                                    if is_resuming and current_round:
-                                        # Get round number from item
-                                        item_round = None
-                                        item_data = item.get("item")
-                                        if item_data:
-                                            # Handle both dict and object access
-                                            if isinstance(item_data, dict):
-                                                item_round = item_data.get("roundNumber")
-                                            elif hasattr(item_data, "roundNumber"):
-                                                item_round = item_data.roundNumber
-                                        
-                                        # When resuming, only include items from current round onwards
-                                        # Exclude items without roundNumber (they're from old rounds before roundNumber was added)
-                                        # Exclude items with roundNumber < current_round (from previous rounds)
-                                        if item_round is None or item_round < current_round:
-                                            continue  # Skip items from previous rounds or without round info
-                                    
-                                    filtered_items.append(item)
-                                
-                                # Emit filtered items directly in exact chatData format: {type, createdAt, item}
-                                for item in filtered_items:
-                                    # Convert Pydantic models to dicts for JSON serialization
-                                    serializable_item = {
-                                        "type": item.get("type"),
-                                        "createdAt": item.get("createdAt"),
-                                        "item": item.get("item").dict() if hasattr(item.get("item"), "dict") else item.get("item")
-                                    }
-                                    yield f"data: {json.dumps(serializable_item)}\n\n"
-                                # Update timestamp to only get new items next time
-                                if chatData["items"]:
-                                    # Parse timestamps and get the maximum
-                                    timestamps = []
-                                    for item in chatData["items"]:
-                                        ts = parseTimestamp(item.get("createdAt"), default=0)
-                                        timestamps.append(ts)
-                                    if timestamps:
-                                        last_chatdata_timestamp = max(timestamps)
-                        except Exception as e:
-                            logger.warning(f"Error fetching chat data: {e}")
-                        last_chatdata_fetch = current_time
-                    
-                    # Try to get event with timeout
+                    # Get event from queue (pure event-driven - no polling database)
                     try:
                         event = await asyncio.wait_for(queue.get(), timeout=1.0)
                         
-                        # Only emit chatdata events (messages, logs, stats) in exact chatData format
-                        # Ignore status/progress/complete/stopped/error events that don't match the format
-                        if event.get("type") == "chatdata" and event.get("data"):
+                        # Handle different event types
+                        event_type = event.get("type")
+                        event_data = event.get("data", {})
+                        
+                        # Emit chatdata events (messages, logs, stats) in exact chatData format
+                        if event_type == "chatdata" and event_data:
                             # Emit item directly in exact chatData format: {type, createdAt, item}
-                            chatdata_item = event.get("data")
+                            chatdata_item = event_data
                             # Ensure item field is serializable (convert Pydantic models to dicts)
                             if isinstance(chatdata_item, dict) and "item" in chatdata_item:
                                 item_obj = chatdata_item.get("item")
@@ -247,26 +185,21 @@ async def stream_chatbot_start(
                                     chatdata_item = chatdata_item.copy()
                                     chatdata_item["item"] = item_obj.dict()
                             yield f"data: {json.dumps(chatdata_item)}\n\n"
-                            # Update timestamp for incremental fetching
-                            if chatdata_item.get("createdAt"):
-                                last_chatdata_timestamp = parseTimestamp(chatdata_item["createdAt"], default=None)
                         
-                        # Check if this is a completion/stopped event to close stream
-                        if event.get("type") == "complete":
+                        # Handle completion/stopped events to close stream
+                        elif event_type == "complete":
                             logger.info(f"Workflow {workflow.id} completed, closing stream")
                             break
-                        elif event.get("type") == "stopped":
-                            # Workflow was stopped, close stream
+                        elif event_type == "stopped":
                             logger.info(f"Workflow {workflow.id} stopped, closing stream")
                             break
-                        elif event.get("type") == "error" and event.get("step") == "error":
-                            # Final error, close stream
+                        elif event_type == "error" and event.get("step") == "error":
                             logger.warning(f"Workflow {workflow.id} error, closing stream")
                             break
                         
-                        last_keepalive = asyncio.get_event_loop().time()
+                        last_keepalive = current_time
                     except asyncio.TimeoutError:
-                        # Send keepalive if needed
+                        # Send keepalive if needed (no events received, but keep connection alive)
                         current_time = asyncio.get_event_loop().time()
                         if current_time - last_keepalive >= keepalive_interval:
                             yield f": keepalive\n\n"
@@ -274,14 +207,12 @@ async def stream_chatbot_start(
                         continue
                     except Exception as e:
                         logger.error(f"Error in event stream: {e}")
-                        yield f"data: {json.dumps({'type': 'error', 'message': f'Stream error: {str(e)}'})}\n\n"
                         break
                 
             except Exception as e:
                 logger.error(f"Error in event stream generator: {e}", exc_info=True)
-                # Don't emit error events that don't match chatData format
             finally:
-                # Stream ends - no final event needed as it doesn't match chatData format
+                # Stream ends - cleanup handled by event manager
                 pass
         
         return StreamingResponse(
@@ -317,10 +248,12 @@ async def stop_chatbot(
         # Emit stopped event to active streams
         event_manager = get_event_manager()
         await event_manager.emit_event(
-            workflowId,
-            "stopped",
-            "Workflow stopped by user",
-            "stopped"
+            context_id=workflowId,
+            event_type="stopped",
+            data={"workflowId": workflowId},
+            event_category="workflow",
+            message="Workflow stopped by user",
+            step="stopped"
         )
         logger.info(f"Emitted stopped event for workflow {workflowId}")
         
